<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

/**
 * Плагин для MaxSite CMS
 * http://max-3000.com/
 * Цветные блоки
 */
 // страница админки плагина color_div
  
	$pattern_default = '<div class="bor-#COLOR# bordered rounded10 mar10 bg-#COLOR#100 pad10 hover-bg-#COLOR#300"><p><i class="i-#TYPE# t300 t-#COLOR#"></i><span class="t150 mar10">#TEXT#</span></p></div>';
	$types_default = array(
	    'info'=>'blue',
		'warning'=>'red',
		'download'=>'green',
		'bookmark'=>'brown',
		'comment'=>'blue',
		'check'=>'green',
		'minus-circle'=>'orange',
		'pencil'=>'purple',
		'plus-circle'=>'green',
		'times-circle'=>'red');  
	$color_default = 'grey';	
		
	mso_cur_dir_lang(__FILE__);

	$options_key = 'color_div';

	if ( $post = mso_check_post(array('f_session_id', 'f_submit')) )
	{
		mso_checkreferer();
		$options = array();
		$options['color_default'] = isset( $post['f_color_default'])   ? $post['f_color_default'] : $color_default;
		$options['pattern'] = isset( $post['f_pattern']) ? $post['f_pattern'] : $pattern_default;
		$post['f_types'] = isset( $post['f_types']) ? $post['f_types'] : $types_default;
		
		if (isset($post['f_types']) and $post['f_types']) 
		{
	      $types = explode("\n", $post['f_types']); // разбиваем по строкам
		  $options['types'] = array();
		  foreach ($types as $type)
		  {
		    $arr = explode("|", $type);
		    if (isset($arr[0]) and trim($arr[0]))
		    {
		      $arr[0] = trim($arr[0]);
              if (isset($arr[0]) and trim($arr[0])) $options['types'][$arr[0]] = trim($arr[1]);
              else $options['types'][$arr[0]] = $options['default_color'];     
            }
		  }
        }
		
		mso_add_option($options_key, $options, 'plugins');

		mso_flush_cache();
		echo '<div class="update">' . t('Обновлено!', 'plugins') . '</div>';
	}

	if ( $post = mso_check_post(array('f_session_id', 'f_restore')) )
	{
		mso_checkreferer();
		$options = array();
		$options['color_default'] = $color_default;
		$options['pattern'] = $pattern_default;
		$post['types'] = $types_default;
		
		mso_add_option($options_key, $options, 'plugins');

		mso_flush_cache();
		echo '<div class="update">' . t('Восстановлено!', 'plugins') . '</div>';
	}

	$options = mso_get_option($options_key, 'plugins', array());
	
	$options['color_default']   = isset($options['color_default'])   ?      $options['color_default']   : $color_default;
	$options['pattern']   = isset($options['pattern'])   ?      $options['pattern']   : $pattern_default;
	$options['types']   = isset($options['types'])   ?      $options['types']   : $types_default;

	$form = '';

	$form .= '<h2>' . t('Основные настройки', 'plugins') . '</h2>';
    $form .= '<p>' . t('Цветные блоки формируются на основе UniCSS и fontawesome.') . '</p>';

	$form .= '<p><strong>' . t('Цвет по умолчанию') . '</strong><input name="f_color_default" type="text" value="' . $options['color_default'] . '"></p>';
	$form .= '<p><strong>' . t('Шаблон') . ' </strong><input name="f_pattern" type="text" value="' . htmlspecialchars($options['pattern']) . '"></p>';
	$form .= '<p>' . htmlspecialchars($pattern_default) . '</p>';	

	// преобразуем массив
	$types = '';
	$types_out = '';
	foreach ($options['types'] as $type=>$color)
    {
	  $text = '[color_div=' . $type . '][/color_div]';
      // меняем #COLOR# #TYPE# #TEXT#
	  $types_out .= str_replace(array('#COLOR#','#TYPE#', '#TEXT#'), array($color, $type, $text), $options['pattern']);
      $types .= $type . ' | ' . $color . NR;
    }
    $form .= '<p>' . t('Шаблон можно подобрать в онлайн редакторе') . ' <a href="http://unicss.maxsite.com.ua/builder">UniCSS Builder</a></p>';
	$form .= '<h2>' . t('Типы блоков', 'plugins') . '</h2>';
	$form .= '<textarea name="f_types" rows="12" cols="40">' . $types . '</textarea>' ;
    $form .= '<p>' . t('Типы блоков подбирать из') . ' <a href="https://fontawesome.com/icons">fontawesome</a></p>';

	echo '<form action="" method="post">' . mso_form_session('f_session_id');
	echo $form;
	echo '<br>
	<input type="submit" name="f_submit" value="' . t('Сохранить изменения', 'plugins') . '" style="margin: 25px 0 5px 0;">
	<input type="submit" name="f_restore" value="' . t('Восстановить исходные', 'plugins') . '" style="margin: 25px 0 5px 0;">
	</form>';
   
    echo '<h2>' . t('Образцы', 'plugins') . '</h2>';
	echo $types_out;

# end of file