<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

/**
 * Плагин для MaxSite CMS
 * http://max-3000.com/
 * Цветные блоки
 */


# функция автоподключения плагина
function color_div_autoload($args = array())
{
	mso_hook_add('editor_markitup_bbcode', 'color_div_buttons', 20); # хук на вывод кнопок
	mso_hook_add('bbcode', 'color_div_custom', 20); # хук на обработку
	if( is_type('admin') )
	{
		// хук на админку
		mso_hook_add('admin_init','color_div_admin_init');
	}
}

# функция выводит дополнительные кнопки
function color_div_buttons($args = array())
{
	$types_default = array(
	    'info'=>'blue',
		'warning'=>'red',
		'download'=>'green',
		'bookmark'=>'brown',
		'comment'=>'blue',
		'check'=>'green',
		'minus-circle'=>'orange',
		'pencil'=>'purple',
		'plus-circle'=>'green',
		'times-circle'=>'red');
	
	$options = mso_get_option('color_div', 'plugins', array());
	$types = isset($options['types']) ? $options['types'] : $types_default;

    $buttons='
		{separator:"---------------"},
		{name:"' . t('Цветные блоки') . '", openBlockWith:"", closeBlockWith:"", className:"add", dropMenu: [
	';	
	foreach ($types as $type=>$color)
	
	   $buttons .= '{name:"' . $type . '", openBlockWith:"[color_div=' . $type . ']", closeBlockWith:"[/color_div]", className:"i-' . $type . '" },';

	$buttons .= '	]},';
	
	echo $buttons;
	return $args;
}


# функция выполняется при деинсталяции плагина
function color_div_uninstall($args = array())
{
	mso_delete_option('color_div', 'plugins' ); // удалим созданные опции
	mso_remove_allow('color_div_edit'); // удалим созданные разрешения

	return $args;
}


# функция замены
function color_div_custom($text = '')
{
	$text = preg_replace_callback('~\[color_div=(.*?)\](.*?)\[\/color_div\]~si', 'color_div_pre_callback', $text );
	return $text;
}


# callback-функция для pre
function color_div_pre_callback($matches)
{
	$color_default = 'grey';
	$pattern_default = '<div class="bor-#COLOR# bordered rounded10 mar10 bg-#COLOR#100 pad10 hover-bg-#COLOR#300"><p><i class="i-#TYPE# t300 t-#COLOR#"></i><span class="t150 mar10">#TEXT#</span></p></div>';
	$types_default = array(
	    'info'=>'blue',
		'warning'=>'red',
		'download'=>'green',
		'bookmark'=>'brown',
		'comment'=>'blue',
		'check'=>'green',
		'minus-circle'=>'orange',
		'pencil'=>'purple',
		'plus-circle'=>'green',
		'times-circle'=>'red');
	
	$options = mso_get_option('color_div', 'plugins', array());
	$pattern = isset($options['pattern']) ? $options['pattern'] : $pattern_default;
	$types = isset($options['types']) ? $options['types'] : $types_default;
	$color_default = isset($options['color_default']) ? $options['color_default'] : $color_default;

	
	$type = $matches[1];
	
	// ищем color
	if (isset($types[$type])) 
		 $color = $types[$type];
    else $color = $color_default;
	
	// меняем #COLOR# #TYPE# #TEXT#
	$m = str_replace(array('#COLOR#','#TYPE#', '#TEXT#'), array($color, $type, $matches[2]), $pattern);

	return $m;
}

function color_div_activate($args = array())
{
	mso_create_allow('color_div_edit',  t('Админ-доступ к настройкам', 'admin'));
	return $args;
}

function color_div_admin_init($args = array())
{
	if ( mso_check_allow('color_div_edit') )
	{
		mso_admin_menu_add('plugins', 'color_div', t('Color_DIV', __FILE__));
		mso_admin_url_hook ('color_div', 'color_div_admin_page');
	}
	return $args;
}


function color_div_admin_page($args = array())
{
	# выносим админские функции отдельно в файл
	if ( !mso_check_allow('color_div_edit') )
	{
		echo t('Доступ запрещен', 'plugins');
		return $args;
	}
	# выносим админские функции отдельно в файл
	mso_hook_add_dinamic( 'mso_admin_header', ' return $args . "' . t('color_div', __FILE__) . '"; ' );
	mso_hook_add_dinamic( 'admin_title', ' return "' . t('color_div', __FILE__) . ' - " . $args; ' );
	require(getinfo('plugins_dir') . 'color_div/admin.php');
}

# end of file